.nolist
#include "ti84pcse.inc"
#include "dcse8.inc"

; declare ram vars here
temp1	.equ cmdShadow
cursorX	.equ temp1				;2 bytes
cursorY	.equ cursorX+2				;2 bytes
.list

	.org UserMem
BinaryStart:
	.db $EF,$11     ;OpenLib(                                    2    2
	.db "D",$BB,$BF,$BB,$BF,$BB,$C2,$BB,$C3,"CSE",$11,$3F  ;    14   16
	.db $EF,$12,$3F ;ExecLib                                     3   19
	.db $D5,$3F     ;Return                                      2   21
	.db tExtTok,tAsm84CPrgm,$3F ;                                3   24 bytes total
HeaderStart:
	.dw ASMStart-HeaderStart ;offset to code
	
	.dw 10
	.db 3
	.db "DoorsCSE",8,0
	
;section
	.dw Header_Desc_End-Header_Desc_Start
	.db 0
Header_Desc_Start:
	.db "Etch-a-Sketch for TI",0
Header_Desc_End:
	
;section
	.dw Header_Icon_End-Header_Icon_End ; (explude type byte)
    .db 1 ;
Header_Icon_Start:
    .db 0
	.db $ff,$ff,$e8,$e4,$00,$00,$7b,$ef
	.db 32
	.db 32
	.db $01,$55,$55,$55,$55,$55,$55,$40
	.db $15,$55,$55,$55,$55,$55,$55,$54
	.db $55,$55,$55,$55,$55,$55,$55,$55
	.db $55,$55,$55,$55,$55,$55,$55,$55
	.db $55,$55,$55,$55,$55,$55,$55,$55
	.db $55,$00,$00,$00,$00,$00,$00,$55
	.db $54,$00,$00,$00,$00,$00,$00,$15
	.db $54,$aa,$aa,$aa,$aa,$aa,$aa,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$80,$00,$00,$00,$00,$02,$15
	.db $54,$aa,$aa,$aa,$aa,$aa,$aa,$15
	.db $54,$00,$00,$00,$00,$00,$00,$15
	.db $54,$ff,$00,$00,$00,$00,$fc,$15
	.db $5f,$ff,$f0,$00,$00,$0f,$ff,$d5
	.db $5f,$ff,$f0,$00,$00,$0f,$ff,$d5
	.db $7f,$ff,$fc,$00,$00,$3f,$ff,$f5
	.db $7f,$ff,$fc,$00,$00,$3f,$ff,$f5
	.db $7f,$ff,$fc,$00,$00,$3f,$ff,$f5
	.db $7f,$ff,$fc,$00,$00,$3f,$ff,$f5
	.db $5f,$ff,$f0,$00,$00,$0f,$ff,$d5
	.db $5f,$ff,$f5,$55,$55,$5f,$ff,$d5
	.db $55,$ff,$55,$55,$55,$55,$fd,$55
	.db $55,$55,$55,$55,$55,$55,$55,$55
	.db $15,$55,$55,$55,$55,$55,$55,$50
	.db $00,$55,$55,$55,$55,$55,$55,$00
Header_Icon_End:
	
;section
	.dw Header_Author_End-Header_Author_Start
	.db 2
Header_Author_Start:
	.db "Andy Chun",0
Header_Author_End:

;end header
	.dw 0
	.db $ff
ASMStart:
	.relocate UserMem
ProgramStart:
	; code here
	call ClearLCDFull
	call Print
	
	ld hl,0Fh ;start @ 0
	ld (cursorX),hl
	ld hl,0Fh
	ld (cursorY),hl
	
	jp RenderLoop
	;;call RenderLoop
	;;B_CALL(_GetKey)
	;;jp EndProgram
KeyLoop:
	B_CALL(_GetCSC) ;get keys pressed
	
	cp skUp
	jp z,KeyUp
	cp skDown
	jp z,KeyDown
	cp skLeft
	jp z,KeyLeft
	cp skRight
	jp z,KeyRight
	cp skDel
	jp z,ClearScreen
	cp skClear
	jp z,EndProgram
	
	jp KeyLoop
RenderLoop:
	push iy
	ld iy,000Fh ;
	ld hl,(cursorX)
	ld de,(cursorY)
	call ColorPixel
	pop iy
	jp KeyLoop
KeyDown:
	ld hl,(cursorY)
	inc hl
yFinish:
	ld (cursorY),hl
	jp RenderLoop
KeyUp:
	ld hl,(cursorY)
	dec hl
	jp yFinish
KeyRight:
	ld hl,(cursorX)
	inc hl
xFinish:
	ld (cursorX),hl
	jp RenderLoop
KeyLeft:
	ld hl,(cursorX)
	dec hl
	jp xFinish
ClearScreen:
	call ClearLCDFull
	call Print
	jp KeyLoop
Print:
	ld a,0
    ld (CURCOL),a
    ld a,8
    ld (CURROW),a
    ld hl,dataText
	B_CALL(_PutS)
	
	ld a,0
    ld (CURCOL),a
    ld a,9
    ld (CURROW),a
    ld hl,dataText2
    B_CALL(_PutS)

	ret
dataText:
	.db "TI-Etch v.2: By Andy Chun",0
dataText2:
	.db "Arrows: Draw, DEL: erase",0
EndProgram:
	ret
.endrelocate
.end